class iaas::role::network (

##Network1 - external
$neutron_external_network1 = '10.10.98.0/24',
$neutron_external_gateway1 = '10.10.98.1',
##Network2 - external
$neutron_external_network2 = '10.10.99.0/24',
$neutron_external_gateway2 = '10.10.99.1',

$mtu = '1438',

){
# Base
  class { 'iaas::profile::base': 
        dns_servers             => $iaas::params::dns_servers,
        dns_searchdomain        => $iaas::params::dns_searchdomain,
  } ->
  class { 'iaas::profile::neutron::router': 
        mtu 			=> $mtu,
        external_network1 	=> $neutron_external_network1, 
        external_gateway1 	=> $neutron_external_gateway1, 
        external_network2 	=> $neutron_external_network2,
        external_gateway2 	=> $neutron_external_gateway2, 
        public_interface 	=> $iaas::params::public_interface,
        data_interface 		=> $iaas::params::admin_interface,
        public_gateway 		=> $iaas::params::public_gateway,
        external_device1 	=> $iaas::params::external_device1,
        external_device2 	=> $iaas::params::external_device2,
        neutron_password	=> $iaas::params::openstack_neutron_password,
        neutron_secret 		=> $iaas::params::openstack_neutron_secret,
        region 			=> iaas::params::region,
        endpoint_main 		=> $iaas::params::main_address,
        endpoint_admin 		=> $iaas::params::admin_address,
  } 
}
